Loading...
Searching...
No Matches
Sip_event

## Data Structures

struct | sip_event_s
| Structure for Event header. More...

## Macros

#define | sip_event(sip)
| Access a SIP Event header structure sip_event_t from sip_t.
#define | SIP_EVENT_INIT()
| Initializer for structure sip_event_t.
#define | SIPTAG_EVENT(x)
| Tag list item for pointer to a Event header structure sip_event_t.
#define | SIPTAG_EVENT_REF(x)
| Tag list item for reference to a Event header pointer.
#define | SIPTAG_EVENT_STR(s)
| Tag list item for string with Event header value.
#define | SIPTAG_EVENT_STR_REF(x)
| Tag list item for reference to a Event header string.

## Typedefs

typedef struct sip_event_s | sip_event_t
| @

## Functions

issize_t | sip_event_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Event header.
issize_t | sip_event_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Event header.
sip_event_t * | sip_event_init (sip_event_t x[1])
| Initialize a structure sip_event_t.
int | sip_is_event (sip_header_t const *header)
| Test if header object is instance of sip_event_t.
sip_event_t * | sip_event_dup (su_home_t *home, sip_event_t const *hdr))
| Duplicate a list of Event header header structures sip_event_t.
sip_event_t * | sip_event_copy (su_home_t *home, sip_event_t const *hdr))
| Copy a list of Event header header structures sip_event_t.
sip_event_t * | sip_event_make (su_home_t *home, char const *s))
| Make a Event header structure sip_event_t.
sip_event_t * | sip_event_format (su_home_t *home, char const *fmt,...)))
| Make a Event header from formatting result.

## Variables

msg_hclass_t | sip_event_class []
| Header class for Event header.
tag_typedef_t | siptag_event
| Tag for Event header object.
tag_typedef_t | siptag_event_str
| Tag for string with Event header value.

## Detailed Description

## Macro Definition Documentation

## SIP_EVENT_INIT

#define SIP_EVENT_INIT | ( |  | ) |

Initializer for structure sip_event_t.

A static sip_event_t structure for Event header must be initialized with the SIP_EVENT_INIT() macro. For instance,

sip_event_t sip_event = SIP_EVENT_INIT;
sip_event_t
struct sip_event_s sip_event_t
@
Definition sip.h:204
SIP_EVENT_INIT
#define SIP_EVENT_INIT()
Initializer for structure sip_event_t.
Definition sip_protos.h:8716
sip_event
#define sip_event(sip)
Access a SIP Event header structure sip_event_t from sip_t.
Definition sip_protos.h:8699

## SIPTAG_EVENT

#define SIPTAG_EVENT | ( |  | x | ) |

Tag list item for pointer to a Event header structure sip_event_t.

The SIPTAG_EVENT() macro is used to include a tag item with a pointer to a sip_event_t structure in a tag list.

Parameters

  x | pointer to a sip_event_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_EVENT_REF().

## SIPTAG_EVENT_STR

#define SIPTAG_EVENT_STR | ( |  | s | ) |

Tag list item for string with Event header value.

The SIPTAG_EVENT_STR() macro is used to include a tag item with a string containing value of a sip_event_t header in a tag list.

Parameters

  s | pointer to a string containing Event header value, or NULL.

The string in SIPTAG_EVENT_STR() can be converted to a sip_event_t header structure by giving the string s has second argument to function sip_event_make().

The corresponding tag taking reference parameter is SIPTAG_EVENT_STR_REF().

## Typedef Documentation

## sip_event_t

typedef struct sip_event_s sip_event_t

@

The Event header is used to indicate the which event or class of events the message contains or subscribes. Its syntax is defined in RFC 3265 as follows:

Event = ( "Event" / "o" ) HCOLON event-type
*( SEMI event-param )
event-type = event-package *( "." event-template )
event-package = token-nodot
event-template = token-nodot
token-nodot = 1*( alphanum / "-" / "!" / "%" / "*"
/ "_" / "+" / "`" / "'" / "~" )
event-param = generic-param / ( "id" EQUAL token )

The parsed Event header is stored in sip_event_t structure.

The structure sip_event_t contains representation of an Event header.

The sip_event_t is defined as follows:

typedef struct sip_event_s
{
sip_common_t o_common; // Common fragment info
sip_error_t *o_next; // Link to next (dummy)
char const * o_type; // Event type
msg_param_t const *o_params; // List of parameters
char const *o_id; // Event ID
} sip_event_t;
sip_error_t
msg_error_t sip_error_t
@
Definition sip.h:134
sip_common_t
msg_common_t sip_common_t
Common part of all the header structures.
Definition sip.h:121
sip_event_s
Structure for Event header.
Definition sip.h:535
sip_event_s::o_next
sip_error_t * o_next
Link to next (dummy).
Definition sip.h:537
sip_event_s::o_id
char const * o_id
Event ID
Definition sip.h:540
sip_event_s::o_common
sip_common_t o_common[1]
Common fragment info.
Definition sip.h:536
sip_event_s::o_params
msg_param_t const * o_params
List of parameters.
Definition sip.h:539
sip_event_s::o_type
char const * o_type
Event type
Definition sip.h:538

## Function Documentation

## sip_event_copy()

sip_event_t * sip_event_copy | ( | su_home_t * | home,
|  | sip_event_t const * | hdr )

inline

Copy a list of Event header header structures sip_event_t.

The function sip_event_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  event = sip_event_copy(home, sip->sip_event);
  sip_event_copy
  sip_event_t * sip_event_copy(su_home_t *home, sip_event_t const *hdr))
  Copy a list of Event header header structures sip_event_t.
  Definition sip_protos.h:8846

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_event_dup()

sip_event_t * sip_event_dup | ( | su_home_t * | home,
|  | sip_event_t const * | hdr )

inline

Duplicate a list of Event header header structures sip_event_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  event = sip_event_dup(home, sip->sip_event);
  sip_event_dup
  sip_event_t * sip_event_dup(su_home_t *home, sip_event_t const *hdr))
  Duplicate a list of Event header header structures sip_event_t.
  Definition sip_protos.h:8803

Returns
  A pointer to the newly duplicated sip_event_t header structure, or NULL upon an error.

## sip_event_format()

sip_event_t * sip_event_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Event header from formatting result.

Make a new sip_event_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_event_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_event_init()

sip_event_t * sip_event_init | ( | sip_event_t | x[1] | ) |

inline

Initialize a structure sip_event_t.

An sip_event_t structure for Event header can be initialized with the sip_event_init() function/macro. For instance,

sip_event_t sip_event;
sip_event_init(&sip_event);
sip_event_init
sip_event_t * sip_event_init(sip_event_t x[1])
Initialize a structure sip_event_t.
Definition sip_protos.h:8734

## sip_event_make()

sip_event_t * sip_event_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Event header structure sip_event_t.

The function sip_event_make() makes a new sip_event_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_event_t header structure, or NULL upon an error.

## sip_is_event()

int sip_is_event | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_event_t.

Check if the header class is an instance of Event header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header event
  0 | (false) otherwise

## Variable Documentation

## sip_event_class

msg_hclass_t sip_event_class[]

extern

Header class for Event header.

The header class sip_event_class defines how a SIP Event header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_event_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.